03-04 創建和編輯AutoCAD實體(四) 編輯二維命名對象 (9)

 

11、Edit Hatches 編輯圖案填充

You can edit both hatch boundaries and hatch patterns. If you edit the boundary of an associative hatch, the pattern is updated as long as the editing results in a valid boundary. Associative hatches are updated even if they're on layers that are turned off. You can modify hatch patterns or choose a new pattern for an existing hatch, but associativity can only be set when a hatch is created. You can check to see if a Hatch object is associative by using the Associative property.

我們可以編輯填充邊界和填充圖案。如果編輯關聯填充的邊界,且編輯後邊界合法,填充圖案就會隨之更新。即便所在的圖層處於關閉狀態,關聯填充也會更新。我們可以修改填充圖案,或爲其選擇新的填充圖案,但是其關聯屬性只在填充創建時才能設置。我們可以使用Associative屬性檢查Hatch對象是否爲關聯的。

You must re-evaluate a hatch using the EvaluateHatch method to see any edits to the hatch.

要想看到編輯後的效果,必須使用EvaluateHatch方法重新對所編輯的填充進行求值。

For more information about editing hatches, see “Modify Hatches and Solid-Filled Areas” in theAutoCAD User's Guide.

更多關於編輯填充的內容,見AutoCAD用戶指南中的“修改圖案填充和實體填充區域”。

11.1、Edit Hatch Boundaries編輯填充邊界

You can append, insert, or remove loops from the boundaries of a Hatch object. Associative hatches are updated to match any changes made to their boundaries. Non-associative hatches are not updated.

我們可以從Hatch對象的邊界中追加、插入及刪除邊界環。關聯性填充會更新以適應邊界變化,非關聯性填充不更新。

To edit a hatch boundary, use one of the following methods:

下列方法用於編輯填充邊界:

AppendLoop

Appends a loop to the hatch. You define the type of loop being appended with first parameter of the AppendLoop method and the constants defined by the HatchLoopTypes enum.

給填充追加一個邊界環,所追加邊界環的類型由AppendLoop方法的第一個參數和HatchLoopTypes枚舉類型的常量定義。

GetLoopAt

Gets the loop at a given index of a hatch. 獲取填充給定索引位置的邊界環。

InsertLoopAt

Inserts a loop at a given index of a hatch. 在填充的給定索引位置插入一個邊界環。

RemoveLoopAt

Deletes a loop at a given index of a hatch. 在填充的給定索引位置刪除一個邊界環。

 

To query a hatch boundary, use one of the following methods:

下列方法用於查詢填充的邊界:

LoopTypeAt

Gets the type of loop at a given index of a hatch. 獲取填充給定索引位置邊界環的類型。

NumberOfLoops

Gets the number of loops of a hatch. 獲取填充的邊界環的個數。

 

Append an inner loop to a hatch 給填充追加一個內部邊界環

This example creates an associative hatch. It then creates a circle and appends the circle as an inner loop to the hatch.

本例創建一個關聯圖案填充,然後創建一個圓並追加該圓作爲填充的內部邊界環。

 

VB.NET

Imports Autodesk.AutoCAD.Runtime

Imports Autodesk.AutoCAD.ApplicationServices

Imports Autodesk.AutoCAD.DatabaseServices

Imports Autodesk.AutoCAD.Geometry

 

<CommandMethod("EditHatchAppendLoop")> _

Public Sub EditHatchAppendLoop()

  '' Get the current document and database

  Dim acDoc As Document = Application.DocumentManager.MdiActiveDocument

  Dim acCurDb As Database = acDoc.Database

 

  '' Start a transaction

  Using acTrans As Transaction = acCurDb.TransactionManager.StartTransaction()

 

      '' Open the Block table for read

      Dim acBlkTbl As BlockTable

      acBlkTbl = acTrans.GetObject(acCurDb.BlockTableId, _

                                   OpenMode.ForRead)

 

      '' Open the Block table record Model space for write

      Dim acBlkTblRec As BlockTableRecord

      acBlkTblRec = acTrans.GetObject(acBlkTbl(BlockTableRecord.ModelSpace), _

                                      OpenMode.ForWrite)

 

      '' Create an arc object for the closed boundary to hatch

      Dim acArc As Arc = New Arc(New Point3d(5, 3, 0), 3, 0, 3.141592)

 

      acBlkTblRec.AppendEntity(acArc)

      acTrans.AddNewlyCreatedDBObject(acArc, True)

 

      '' Create an line object for the closed boundary to hatch

      Dim acLine As Line = New Line(acArc.StartPoint, acArc.EndPoint)

 

      acBlkTblRec.AppendEntity(acLine)

      acTrans.AddNewlyCreatedDBObject(acLine, True)

 

      '' Adds the arc and line to an object id collection

      Dim acObjIdColl As ObjectIdCollection = New ObjectIdCollection()

      acObjIdColl.Add(acArc.ObjectId)

      acObjIdColl.Add(acLine.ObjectId)

 

      '' Create the hatch object and append it to the block table record

      Dim acHatch As Hatch = New Hatch()

      acBlkTblRec.AppendEntity(acHatch)

      acTrans.AddNewlyCreatedDBObject(acHatch, True)

 

      '' Set the properties of the hatch object

      '' Associative must be set after the hatch object is appended to the

      '' block table record and before AppendLoop

      acHatch.SetHatchPattern(HatchPatternType.PreDefined, "ANSI31")

      acHatch.Associative = True

      acHatch.AppendLoop(HatchLoopTypes.Outermost, acObjIdColl)

 

      '' Create a circle object for the inner boundary of the hatch

      Dim acCirc As Circle = New Circle()

      acCirc.Center = New Point3d(5, 4.5, 0)

      acCirc.Radius = 1

 

      acBlkTblRec.AppendEntity(acCirc)

      acTrans.AddNewlyCreatedDBObject(acCirc, True)

 

      '' Adds the circle to an object id collection

      acObjIdColl.Clear()

      acObjIdColl.Add(acCirc.ObjectId)

 

      '' Append the circle as the inner loop of the hatch and evaluate it

      acHatch.AppendLoop(HatchLoopTypes.Default, acObjIdColl)

      acHatch.EvaluateHatch(True)

 

      '' Save the new object to the database

      acTrans.Commit()

  End Using

End Sub

 

C#

using Autodesk.AutoCAD.Runtime;

using Autodesk.AutoCAD.ApplicationServices;

using Autodesk.AutoCAD.DatabaseServices;

using Autodesk.AutoCAD.Geometry;

 

[CommandMethod("EditHatchAppendLoop")]

public static void EditHatchAppendLoop()

{

  // Get the current document and database獲取當前文檔和數據庫

  Document acDoc = Application.DocumentManager.MdiActiveDocument;

  Database acCurDb = acDoc.Database;

 

  // Start a transaction啓動事務

  using (Transaction acTrans = acCurDb.TransactionManager.StartTransaction())

  {

      // Open the Block table for read以讀打開塊表

      BlockTable acBlkTbl;

      acBlkTbl = acTrans.GetObject(acCurDb.BlockTableId,

                                   OpenMode.ForRead) as BlockTable;

 

      // Open the Block table record Model space for write以寫打開塊表記錄模型空間

      BlockTableRecord acBlkTblRec;

      acBlkTblRec = acTrans.GetObject(acBlkTbl[BlockTableRecord.ModelSpace],

                                      OpenMode.ForWrite) as BlockTableRecord;

 

      // Create an arc object for the closed boundary to hatch創建一個圓弧對象作爲填充的閉合邊界

      Arc acArc = new Arc(new Point3d(5, 3, 0), 3, 0, 3.141592);

 

      acBlkTblRec.AppendEntity(acArc);

      acTrans.AddNewlyCreatedDBObject(acArc, true);

 

      // Create an line object for the closed boundary to hatch創建一個直線對象作爲填充的閉合邊界

      Line acLine = new Line(acArc.StartPoint, acArc.EndPoint);

 

      acBlkTblRec.AppendEntity(acLine);

      acTrans.AddNewlyCreatedDBObject(acLine, true);

 

      // Adds the arc and line to an object id collection將圓弧和直線添加到ObjectIdCollection

      ObjectIdCollection acObjIdColl = new ObjectIdCollection();

      acObjIdColl.Add(acArc.ObjectId);

      acObjIdColl.Add(acLine.ObjectId);

 

      // Create the hatch object and append it to the block table record創建Hatch對象

      Hatch acHatch = new Hatch();

      acBlkTblRec.AppendEntity(acHatch);

      acTrans.AddNewlyCreatedDBObject(acHatch, true);

 

      // Set the properties of the hatch object設置填充對象的屬性

      // Associative must be set after the hatch object is appended to the

      // block table record and before AppendLoop關聯屬性必須在將填充對象添加到塊表記錄之後、執行AppendLoop之前設置

      acHatch.SetHatchPattern(HatchPatternType.PreDefined, "ANSI31");

      acHatch.Associative = true;

      acHatch.AppendLoop(HatchLoopTypes.Outermost, acObjIdColl);

 

      // Create a circle object for the inner boundary of the hatch創建一個圓對象作爲填充的內部邊界

      Circle acCirc = new Circle();

      acCirc.Center = new Point3d(5, 4.5, 0);

      acCirc.Radius = 1;

 

      acBlkTblRec.AppendEntity(acCirc);

      acTrans.AddNewlyCreatedDBObject(acCirc, true);

 

      // Adds the circle to an object id collection將圓添加到ObjectIdCollection

      acObjIdColl.Clear();

      acObjIdColl.Add(acCirc.ObjectId);

 

      // Append the circle as the inner loop of the hatch and evaluate it追加圓爲內部邊界環並對填充對象取值

      acHatch.AppendLoop(HatchLoopTypes.Default, acObjIdColl);

      acHatch.EvaluateHatch(true);

 

      // Save the new object to the database保存到數據庫

      acTrans.Commit();

  }

}

 

VBA/ActiveX Code Reference

Sub EditHatchAppendLoop()

    Dim hatchObj As AcadHatch

    Dim patternName As String

    Dim PatternType As Long

    Dim bAssociativity As Boolean

 

    ' Define and create the hatch

    patternName = "ANSI31"

    PatternType = 0

    bAssociativity = True

    Set hatchObj = ThisDrawing.ModelSpace. _

                       AddHatch(PatternType, patternName, bAssociativity)

 

    ' Create the outer loop for the hatch.

    Dim outerLoop(0 To 1) As AcadEntity

    Dim center(0 To 2) As Double

    Dim radius As Double

    Dim startAngle As Double

    Dim endAngle As Double

    center(0) = 5: center(1) = 3: center(2) = 0

    radius = 3

    startAngle = 0

    endAngle = 3.141592

    Set outerLoop(0) = ThisDrawing.ModelSpace. _

                           AddArc(center, radius, startAngle, endAngle)

    Set outerLoop(1) = ThisDrawing.ModelSpace. _

                           AddLine(outerLoop(0).startPoint, outerLoop(0).endPoint)

 

    ' Append the outer loop to the hatch object

    hatchObj.AppendOuterLoop (outerLoop)

 

    ' Create a circle as the inner loop for the hatch.

    Dim innerLoop(0) As AcadEntity

    center(0) = 5: center(1) = 4.5: center(2) = 0

    radius = 1

    Set innerLoop(0) = ThisDrawing.ModelSpace. _

                           AddCircle(center, radius)

 

    ' Append the circle as an inner loop to the hatch

    hatchObj.AppendInnerLoop (innerLoop)

 

    ' Evaluate and display the hatch

    hatchObj.Evaluate

    ThisDrawing.Regen True

End Sub

 

11.2、Edit Hatch Patterns編輯填充圖案

You can change the angle or spacing of an existing hatch pattern or replace it with a solid-fill, gradient fill, or one of the predefined patterns that AutoCAD offers. The Pattern option in the Boundary Hatch dialog box displays a list of these patterns. To reduce file size, the hatch is defined in the drawing as a single graphic object.

我們可以修改現有填充圖案的角度或間隔,或者用實體填充、漸變色填充以及AutoCAD提供的預定義填充圖案來替換現有填充圖案。邊界填充對話框的圖案選項顯示了這些圖案的列表。爲減小文件大小,在圖形中將填充圖案定義爲單獨的圖像對象。

Use the following properties and methods to edit the hatch patterns:

下列屬性和方法用於編輯填充圖案:

GradientAngle

Specifies the gradient angle of the hatch. 指定填充的漸變色角度

GradientName

Returns the gradient name of the hatch. 返回填充的漸變色名稱

GradientShift

Specifies the gradient shift of the hatch. 指定填充的漸變插值

GradientType

Returns the gradient type of the hatch. 返回填充的漸變色類型

PatternAngle

Specifies the angle of the hatch pattern. 指定填充圖案的角度

PatternDouble

Specifies if the user-defined hatch is double-hatched. 指定用戶自定義填充是否爲雙填充?

PatternName

Returns the hatch pattern name of the hatch. (Use the SetHatchPattern method to set the hatch pattern name and type of the hatch.) 返回填充圖案的名稱(使用SetHatchPattern方法設置填充的名稱和類型)

PatternScale

Specifies the hatch pattern scale. 指定填充比例

PatternSpace

Specifies the user-defined hatch pattern spacing. 指定用戶自定義填充的間隔

PatternType

Returns the hatch pattern type of the hatch. (Use the SetHatchPattern method to set the hatch pattern name and type of the hatch.) 返回填充圖案的類型(使用SetHatchPattern方法設置填充的名稱和類型)

SetGradient

Sets the gradient type and name for the hatch. 設置漸變填充的名稱和類型

SetHatchPattern

Sets the pattern type and name for the hatch. 設置填充的名稱和類型

Change the pattern spacing of a hatch 修改填充圖案的間距

This example creates a hatch. It then adds two to the current pattern spacing for the hatch.

本例創建一個圖案填充,然後將該填充圖案的間距加2。

 

VB.NET

Imports Autodesk.AutoCAD.Runtime

Imports Autodesk.AutoCAD.ApplicationServices

Imports Autodesk.AutoCAD.DatabaseServices

Imports Autodesk.AutoCAD.Geometry

 

<CommandMethod("EditHatchPatternScale")> _

Public Sub EditHatchPatternScale()

  '' Get the current document and database

  Dim acDoc As Document = Application.DocumentManager.MdiActiveDocument

  Dim acCurDb As Database = acDoc.Database

 

  '' Start a transaction

  Using acTrans As Transaction = acCurDb.TransactionManager.StartTransaction()

 

      '' Open the Block table for read

      Dim acBlkTbl As BlockTable

      acBlkTbl = acTrans.GetObject(acCurDb.BlockTableId, _

                                   OpenMode.ForRead)

 

      '' Open the Block table record Model space for write

      Dim acBlkTblRec As BlockTableRecord

      acBlkTblRec = acTrans.GetObject(acBlkTbl(BlockTableRecord.ModelSpace), _

                                      OpenMode.ForWrite)

 

      '' Create a circle object for the boundary of the hatch

      Dim acCirc As Circle = New Circle()

      acCirc.Center = New Point3d(5, 3, 0)

      acCirc.Radius = 3

 

      acBlkTblRec.AppendEntity(acCirc)

      acTrans.AddNewlyCreatedDBObject(acCirc, True)

 

      '' Adds the arc and line to an object id collection

      Dim acObjIdColl As ObjectIdCollection = New ObjectIdCollection()

      acObjIdColl.Add(acCirc.ObjectId)

 

      '' Create the hatch object and append it to the block table record

      Dim acHatch As Hatch = New Hatch()

      acBlkTblRec.AppendEntity(acHatch)

      acTrans.AddNewlyCreatedDBObject(acHatch, True)

 

      '' Set the properties of the hatch object

      '' Associative must be set after the hatch object is appended to the

      '' block table record and before AppendLoop

      acHatch.SetHatchPattern(HatchPatternType.PreDefined, "ANSI31")

      acHatch.Associative = True

      acHatch.AppendLoop(HatchLoopTypes.Outermost, acObjIdColl)

 

      '' Evaluate the hatch

      acHatch.EvaluateHatch(True)

 

      '' Increase the pattern scale by 2 and re-evaluate the hatch

      acHatch.PatternScale = acHatch.PatternScale + 2

      acHatch.SetHatchPattern(acHatch.PatternType, acHatch.PatternName)

      acHatch.EvaluateHatch(True)

 

      '' Save the new object to the database

      acTrans.Commit()

  End Using

End Sub

 

C#

using Autodesk.AutoCAD.Runtime;

using Autodesk.AutoCAD.ApplicationServices;

using Autodesk.AutoCAD.DatabaseServices;

using Autodesk.AutoCAD.Geometry;

 

[CommandMethod("EditHatchPatternScale")]

public static void EditHatchPatternScale()

{

  // Get the current document and database

  Document acDoc = Application.DocumentManager.MdiActiveDocument;

  Database acCurDb = acDoc.Database;

 

  // Start a transaction

  using (Transaction acTrans = acCurDb.TransactionManager.StartTransaction())

  {

      // Open the Block table for read

      BlockTable acBlkTbl;

      acBlkTbl = acTrans.GetObject(acCurDb.BlockTableId,

                                   OpenMode.ForRead) as BlockTable;

 

      // Open the Block table record Model space for write

      BlockTableRecord acBlkTblRec;

      acBlkTblRec = acTrans.GetObject(acBlkTbl[BlockTableRecord.ModelSpace],

                                      OpenMode.ForWrite) as BlockTableRecord;

 

      // Create a circle object for the boundary of the hatch

      Circle acCirc = new Circle();

      acCirc.Center = new Point3d(5, 3, 0);

      acCirc.Radius = 3;

 

      acBlkTblRec.AppendEntity(acCirc);

      acTrans.AddNewlyCreatedDBObject(acCirc, true);

 

      // Adds the circle to an object id collection

      ObjectIdCollection acObjIdColl = new ObjectIdCollection();

      acObjIdColl.Add(acCirc.ObjectId);

 

      // Create the hatch object and append it to the block table record

      Hatch acHatch = new Hatch();

      acBlkTblRec.AppendEntity(acHatch);

      acTrans.AddNewlyCreatedDBObject(acHatch, true);

 

      // Set the properties of the hatch object設置填充對象屬性

      // Associative must be set after the hatch object is appended to the block table record and before AppendLoop

      // 關聯屬性必須在將填充對象添加到塊表記錄之後、執行AppendLoop之前設置

      acHatch.SetHatchPattern(HatchPatternType.PreDefined, "ANSI31");

      acHatch.Associative = true;

      acHatch.AppendLoop(HatchLoopTypes.Outermost, acObjIdColl);

 

      // Evaluate the hatch計算填充

      acHatch.EvaluateHatch(true);

 

      // Increase the pattern scale by 2 and re-evaluate the hatch填充圖案的比例加2,重新計算填充

      acHatch.PatternScale = acHatch.PatternScale + 2;

      acHatch.SetHatchPattern(acHatch.PatternType, acHatch.PatternName);

      acHatch.EvaluateHatch(true);

 

      // Save the new object to the database保存到數據庫

      acTrans.Commit();

  }

}

 

VBA/ActiveX Code Reference

Sub EditHatchPatternScale()

    Dim hatchObj As AcadHatch

    Dim patternName As String

    Dim PatternType As Long

    Dim bAssociativity As Boolean

 

    ' Define the hatch

    patternName = "ANSI31"

    PatternType = 0

    bAssociativity = True

 

    ' Create the associative Hatch object

    Set hatchObj = ThisDrawing.ModelSpace. _

                       AddHatch(PatternType, patternName, bAssociativity)

 

    ' Create the outer loop for the hatch.

    Dim outerLoop(0 To 0) As AcadEntity

    Dim center(0 To 2) As Double

    Dim radius As Double

    center(0) = 5

    center(1) = 3

    center(2) = 0

    radius = 3

    Set outerLoop(0) = ThisDrawing.ModelSpace. _

                           AddCircle(center, radius)

    hatchObj.AppendOuterLoop (outerLoop)

    hatchObj.Evaluate

 

    ' Change the scale of the hatch pattern by

    ' adding 2 to the current scale

    hatchObj.patternScale = hatchObj.patternScale + 2

    hatchObj.Evaluate

    ThisDrawing.Regen True

End Sub

 

發佈了4 篇原創文章 · 獲贊 20 · 訪問量 16萬+
發表評論
所有評論
還沒有人評論,想成為第一個評論的人麼? 請在上方評論欄輸入並且點擊發布.
相關文章